unit Ntdll;

{$IMPORTEDDATA OFF}
{$MINENUMSIZE 4}

interface

uses
  Windows;

type
  NTSTATUS = Longint;
  ULONG_PTR = ULONG;

  TProcessInfoClass = (
    ProcessBasicInformation = 0
  );

  TProcessBasicInformation = record
    Reserved1: Pointer;
    PebBaseAddress: Pointer;
    Reserved2: array [0..1] of Pointer;
    UniqueProcessId: ULONG_PTR;
    InheritedFromUniqueProcessId: ULONG_PTR;
  end;

  TSystemInformationClass = (
    SystemTimeOfDayInformation = 3,
    SystemProcessorTimes = 8
  );

  TSystemTimeOfDayInformation = record
    liKeBootTime: TLargeInteger;
    liKeSystemTime: TLargeInteger;
    liExpTimeZoneBias: TLargeInteger;
    uCurrentTimeZoneId: ULONG;
    dwReserved: DWORD;
  end;

  TSystemProcessorTimes = record
    liIdleTime: TLargeInteger;
    liKernelIdleTime: TLargeInteger;
    liUserOtherTime: TLargeInteger;
    dwSpare: array [0..5] of DWORD;
  end;

var
  NtCurrentTeb: function: Pointer; stdcall;
  NtQueryInformationProcess: function (ProcessHandle: THandle;
    ProcessInformationClass: TProcessInfoClass; ProcessInformation: Pointer;
    ProcesssInformationLength: ULONG; ReturnLength: PULONG): NTSTATUS; stdcall;
  NtQuerySystemInformation: function (
    SystemInformationClass: TSystemInformationClass;
    SystemInformation: Pointer; SystemInformationLength: ULONG;
    ReturnLength: PULONG): NTSTATUS; stdcall;

implementation

uses NDllLoader;

var
  h: HMODULE;
begin
  h := LoadDLL('ntdll.dll');
  if h = 0 then
    Exit;
  NtCurrentTeb := GetProcAddress(h, 'NtCurrentTeb');
  NtQueryInformationProcess := GetProcAddress(h, 'NtQueryInformationProcess');
  NtQuerySystemInformation := GetProcAddress(h, 'NtQuerySystemInformation');
end.
